> ## Documentation Index
> Fetch the complete documentation index at: https://docs.incident.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Bulk Update Entries

> Update multiple catalog entries in a single operation. You can update up to 250 entries at once. This operation is atomic - either all entries are updated successfully, or none are updated.



## OpenAPI

````yaml /openapi/tags/catalog-entries-v3.json post /v3/catalog_entries/actions/bulk_update
openapi: 3.0.3
info:
  description: "This is the API reference for incident.io.\n\nIt documents available API endpoints, provides examples of how to use it, and\ninstructions around things like authentication and error handling.\n\nThe API is hosted at:\n\n- https://api.incident.io/\n\nAnd you will need to create an API key via your [incident.io\ndashboard](https://app.incident.io/settings/api-keys) to make requests.\n\n# Making requests\n\nHere are the key concepts required to make requests to the incident.io API.\n\n## Authentication\n\nFor all requests made to the incident.io API, you'll need an API key.\n\nTo create an API key, head to the incident dashboard and visit [API\nkeys](https://app.incident.io/settings/api-keys). When you create the key, you'll be able to choose what actions it\ncan take for your account: choose carefully, as those roles can only be set\nwhen you first create the key. We'll only show you the token once, so make sure\nyou store it somewhere safe.\n\nAPI keys are global to your incident.io account, and can be managed by anyone\nwho has the right permissions. We display the user that created the API key,\nand the API key will remain valid if that user becomes deactivated.\n\nOnce you have the key, you should make requests to the API that set the\n`Authorization` request header using a \"Bearer\" authentication scheme:\n\n```\nAuthorization: Bearer <YOUR_API_KEY>\n```\n\n## Rate Limits\n\nThe incident.io API enforces rate limits to ensure consistent performance for all users.\n\nThe default rate limit is 1200 requests/minute per API key. This limit applies to most endpoints across the API.\n\nSome endpoints have lower rate limits, particularly those that interact with external third-party systems that impose\ntheir own limitations. These specific limits vary by endpoint, and we recommend relying on the rate-limit error\nresponses to understand usage patterns and implement appropriate retry strategies.\n\nWhen you exceed a rate limit, the API will respond with a `429 Too Many Requests` status code, along with a JSON\nresponse that includes information about the limit and when you can retry:\n\n```json\n{\n    \"type\": \"too_many_requests\",\n    \"status\": 429,\n    \"request_id\": \"b839a403-7704-41c1-bf6a-39a2d68caefa\",\n    \"rate_limit\": {\n        \"name\": \"api_key_name\",\n        \"limit\": 1200,\n        \"remaining\": 0,\n        \"retry_after\": \"Thu, 17 Apr 2025 11:17:18 UTC\"\n    },\n    \"errors\": [\n        {\n            \"code\": \"too_many_requests\",\n            \"message\": \"Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.\"\n        }\n    ]\n}\n```\n\nThe response includes:\n* The name of the API key (`name`)\n* The bucket limit (`limit`)\n* The number of requests remaining (`remaining`)\n* When you can retry requests (`retry_after`)\n\n## Errors\n\nWe use standard HTTP response codes to indicate the status or failure of API\nrequests.\n\nThe API response body will be JSON, and contain more detailed information on the\nnature of the error.\n\nAn example error when a request is made without an API key:\n\n```json\n{\n  \"type\": \"authentication_error\",\n  \"status\": 401,\n  \"request_id\": \"8e3cc412-b49d-4957-9073-2c19d2c61804\",\n  \"errors\": [\n    {\n      \"code\": \"missing_authorization_material\",\n      \"message\": \"No authorization material provided in request\"\n    }\n  ]\n}\n```\n\nNote that the error:\n\n- Contains the HTTP status (`401`)\n- References the type of error (`authentication_error`)\n- Includes a `request_id` that can be provided to incident.io support to help\n\tdebug questions with your API request\n- Provides a list of individual errors, which go into detail about why the error\n\toccurred\n\nThe most common error will be a 422 Validation Error, which is returned when the\nrequest was rejected due to failing validations.\n\nThese errors look like this:\n\n```json\n{\n  \"type\": \"validation_error\",\n  \"status\": 422,\n  \"request_id\": \"631766c4-4afd-4803-997c-cd700928fa4b\",\n  \"errors\": [\n    {\n      \"code\": \"is_required\",\n      \"message\": \"A severity is required to open an incident\",\n      \"source\": {\n        \"field\": \"severity_id\"\n      }\n    }\n  ]\n}\n```\n\nThis error is caused by not providing a severity identifier, which should be at\nthe `severity_id` field of the request payload. Errors like these can be mapped to\nforms, should you be integrating with the API from a user-interface.\n\n## Compatibility\n\nWe won't make breaking changes to existing API services or endpoints, but will\nexpect integrators to upgrade themselves to the latest API endpoints within 3\nmonths of us deprecating the old service.\n\nWe will make changes that are considered backwards compatible, which include:\n\n- Adding new API endpoints and services\n- Adding new properties to responses from existing API endpoints\n- Reordering properties returned from existing API endpoints\n- Adding optional request parameters to existing API endpoints\n- Altering the format or length of IDs\n- Adding new values to enums\n\nIt is important that clients are robust to these changes, to ensure reliable\nintegrations.\n\nAs an example, if you are generating a client using an openapi-generator, ensure\nthe generated client is configured to support unknown enum values, often\nconfigured via the `enumUnknownDefaultCase` parameter.\n\nWhen breaking changes are unavoidable, we'll create a new service version on a\nseparate path, and run them in parallel.\n\nFor example:\n\n- https://api.incident.io/v1/incidents\n- https://api.incident.io/v2/incidents\n\nFor any questions, email support@incident.io.\n"
  title: incident.io
  version: 1.0.0
servers:
  - url: https://api.incident.io
security:
  - BearerAuth: []
tags:
  - description: >
      Manage and browse catalog resources.


      Use the incident.io catalog to track services, teams, product features and
      anything

      else that helps build a map of your organisation. These different
      categories of thing

      become catalog types, and each instance (like a particular service or
      team) is a

      catalog entry.


      Each type is made up of a series of attributes, and each attribute has a
      type. Types

      can even have attributes that refer to other catalog types.


      We automatically create catalog types when you connect an integration,
      such as GitHub

      repositories or PagerDuty services and teams. You can use this API to
      create custom

      types, that are specifically tailored to your organisation.


      Examples might be a 'Service' type with an 'Alert channel' which you can
      point at a

      Slack channel, or 'Team' which specifies its 'Manager' and 'Technical
      Lead' as Slack

      users. You can then use these types to create powerful new workflows.


      Consider using our official [catalog
      importer](https://github.com/incident-io/catalog-importer).

      It can be used to sync catalog data from sources like local files or
      GitHub and push

      them into the incident.io catalog without having to directly interact with
      our public API.
    name: Catalog Entries V3
paths:
  /v3/catalog_entries/actions/bulk_update:
    post:
      tags:
        - Catalog Entries V3
      summary: Bulk Update Entries
      description: >-
        Update multiple catalog entries in a single operation. You can update up
        to 250 entries at once. This operation is atomic - either all entries
        are updated successfully, or none are updated.
      operationId: Catalog V3_BulkUpdateEntries
      requestBody:
        content:
          application/json:
            example:
              catalog_type_id: 01GW2G3V0S59R238FAHPDS1R66
              entries:
                - aliases:
                    - abc123
                  attribute_values:
                    abc123:
                      array_value:
                        - literal: SEV123
                      value:
                        literal: SEV123
                  entry_id: abc123
                  external_id: abc123
                  name: abc123
                  rank: 1
                - aliases:
                    - abc123
                  attribute_values:
                    abc123:
                      array_value:
                        - literal: SEV123
                      value:
                        literal: SEV123
                  entry_id: abc123
                  external_id: abc123
                  name: abc123
                  rank: 1
              update_attributes:
                - 01GW2G3V0S59R238FAHPDS1R66
                - 01GW2G3V0S59R238FAHPDS1R67
            schema:
              $ref: '#/components/schemas/CatalogBulkUpdateEntriesPayloadV3'
        required: true
      responses:
        '204':
          description: No Content response.
components:
  schemas:
    CatalogBulkUpdateEntriesPayloadV3:
      example:
        catalog_type_id: 01GW2G3V0S59R238FAHPDS1R66
        entries:
          - aliases:
              - abc123
            attribute_values:
              abc123:
                array_value:
                  - literal: SEV123
                value:
                  literal: SEV123
            entry_id: abc123
            external_id: abc123
            name: abc123
            rank: 1
          - aliases:
              - abc123
            attribute_values:
              abc123:
                array_value:
                  - literal: SEV123
                value:
                  literal: SEV123
            entry_id: abc123
            external_id: abc123
            name: abc123
            rank: 1
        update_attributes:
          - 01GW2G3V0S59R238FAHPDS1R66
          - 01GW2G3V0S59R238FAHPDS1R67
      properties:
        catalog_type_id:
          description: The unique identifier of the catalog type containing the entries
          example: 01GW2G3V0S59R238FAHPDS1R66
          type: string
        entries:
          description: >-
            A list of entries to update with their new values. Maximum 250
            entries per request.
          example:
            - aliases:
                - abc123
              attribute_values:
                abc123:
                  array_value:
                    - literal: SEV123
                  value:
                    literal: SEV123
              entry_id: abc123
              external_id: abc123
              name: abc123
              rank: 1
            - aliases:
                - abc123
              attribute_values:
                abc123:
                  array_value:
                    - literal: SEV123
                  value:
                    literal: SEV123
              entry_id: abc123
              external_id: abc123
              name: abc123
              rank: 1
          items:
            $ref: '#/components/schemas/PartialEntryPayloadV3'
          maxItems: 250
          minItems: 1
          type: array
        update_attributes:
          description: >-
            Optional list of specific attribute IDs to update across all
            entries. When provided, only these attributes in attribute_values
            will be updated and all other attributes will be preserved. This
            parameter only affects attribute_values - it does not affect core
            entry fields like name, rank, aliases, or external_id, which follow
            their individual omission rules.
          example:
            - 01GW2G3V0S59R238FAHPDS1R66
            - 01GW2G3V0S59R238FAHPDS1R67
          items:
            example: abc123
            type: string
          type: array
      required:
        - catalog_type_id
        - entries
      type: object
    PartialEntryPayloadV3:
      description: Represents a partial entry update, allowing selective field updates
      example:
        aliases:
          - abc123
        attribute_values:
          abc123:
            array_value:
              - literal: SEV123
            value:
              literal: SEV123
        entry_id: abc123
        external_id: abc123
        name: abc123
        rank: 1
      properties:
        aliases:
          description: >-
            If specified, will update the aliases of the entry. When omitted,
            preserves the existing aliases.
          example:
            - abc123
          items:
            example: abc123
            type: string
          type: array
        attribute_values:
          additionalProperties:
            $ref: '#/components/schemas/CatalogEngineParamBindingPayloadV3'
          description: The attribute values to apply to this entry
          example:
            abc123:
              array_value:
                - literal: SEV123
              value:
                literal: SEV123
          type: object
        entry_id:
          description: ID of the relevant catalog entry
          example: abc123
          type: string
        external_id:
          description: >-
            If specified, will update the external ID of the entry. When
            omitted, preserves the existing external ID.
          example: abc123
          type: string
        name:
          description: >-
            If specified, will update the name of the entry. When omitted,
            preserves the existing name.
          example: abc123
          type: string
        rank:
          description: >-
            If specified, will update the rank of the entry. When omitted, rank
            will be set to null (allowing rank removal).
          example: 1
          format: int32
          type: integer
      required:
        - entry_id
        - attribute_values
      type: object
    CatalogEngineParamBindingPayloadV3:
      example:
        array_value:
          - literal: SEV123
        value:
          literal: SEV123
      properties:
        array_value:
          description: If set, this is the array value of the step parameter
          example:
            - literal: SEV123
          items:
            $ref: '#/components/schemas/CatalogEngineParamBindingValuePayloadV3'
          type: array
        value:
          $ref: '#/components/schemas/CatalogEngineParamBindingValuePayloadV3'
      type: object
    CatalogEngineParamBindingValuePayloadV3:
      example:
        literal: SEV123
      properties:
        literal:
          description: If set, this is the literal value of the step parameter
          example: SEV123
          type: string
      type: object
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: API key from your incident.io dashboard (Settings → API keys)

````